function nc = noObstacle(x_initial, position, obstacle)
% This function checks if the way between n2 and n1 is obstacle free

cellSize = max(size(obstacle));
nc = 0;

for i = 1:1:cellSize
    obs = obstacle{i};
    arraySize = length(obs(:,1));
    arrayDimension = length(obs(1,:));
    % Control for correct input
    if arraySize < 3
        error('Array Size too small!')
    end
    if arrayDimension ~= 2
        error('Array Dimension not 2!')
    end
    % First a broad check      
    Xmin = min(obs(:,1));
    Xmax = max(obs(:,1));
    Ymin = min(obs(:,2));
    Ymax = max(obs(:,2));
    if (position(1) < Xmin || position(1) > Xmax || position(2) < Ymin || position(2) > Ymax)
        continue
    end
    
    % Second if the above was not true
    % Check if the line from x_initial to position crosses an even or odd
    % number of edges. Even number: 
    % Assume P1(x1,y1) = x_initial, P2(x2,y2) = position
    ObsHold = [obs; obs(1,:)];
    count = 0;
    for j = 1:1:arraySize
        x=[position(1) x_initial(1) ObsHold(j,1) ObsHold(j+1,1)];
        y=[position(2) x_initial(2) ObsHold(j,2) ObsHold(j+1,2)];
        dt1=det([1,1,1;x(1),x(2),x(3);y(1),y(2),y(3)]) ...
                    * det([1,1,1;x(1),x(2),x(4);y(1),y(2),y(4)]);
        dt2=det([1,1,1;x(1),x(3),x(4);y(1),y(3),y(4)]) ...
                    * det([1,1,1;x(2),x(3),x(4);y(2),y(3),y(4)]);
        if(dt1<=0 && dt2<=0)
            count = count + 1;         % If lines intesect, count up
        end
    end
    % check if count is an odd number
    if mod(count,2)
        nc = 1;
        return
    end
end

end